# $Revision: 1.33 $, $Date: 2002/11/17 20:14:41 $

# conditional build
# _without_dist_kernel          without kernel from distribution

%define		_kernel24	%(echo %{_kernel_ver} | grep -q '2\.[012]\.' ; echo $?)

Summary:	drbd is a block device designed to build high availibility clusters
Summary(pl):	drbd jest urzdzeniem blokowym dla klastrw o wysokiej niezawodnoci
Name:		drbd
Version:	0.5.8.1
%define	rel	14
Release:	%{rel}
License:	GPL
Group:		Base/Kernel
Source0:	http://www.complang.tuwien.ac.at/reisner/drbd/download/%{name}-%{version}.tar.gz
Patch0:		%{name}-kernel24.patch
URL:		http://www.complang.tuwien.ac.at/reisner/drbd/
%{!?_without_dist_kernel:BuildRequires:	kernel-headers >= 2.2.20}
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%description
drbd is a block device which is designed to build high availability
clusters. This is done by mirroring a whole block device via (a
dedicated) network. You could see it as a network RAID1.

%description -l pl
drbd jest urzdzeniem blokowym zaprojektowanym dla klastrw o wysokiej
niezawodnoci. drbd dziaa jako mirroring caego urzdzenia blokowego
przez (dedykowan) sie. Moe by widoczny jako sieciowy RAID1.

%description -l pt_BR
O DRBD  um dispositivo de bloco que  projetado para construir
clusters de Alta Disponibilidade. Isto  feito espelhando um
dispositivo de bloco inteiro via rede (dedicada ou no). Pode ser
visto como um RAID 1 via rede. Este pacote contm utilitrios para
gerenciar dispositivos DRBD.

%package -n drbdsetup
Summary:	Setup tool and scripts for DRBD
Summary(pl):	Narzdzie konfiguracyjne i skrypty dla DRBD
Summary(pt_BR):	Utilitrios para gerenciar dispositivos DRBD
Group:		Applications/System
Prereq:		rc-scripts
Prereq:		chkconfig

%description -n drbdsetup
Setup tool and init scripts for DRBD.

%description -n drbdsetup -l pl
Narzdzie konfiguracyjne i skrypty startowe dla DRBD.

%package -n kernel-block-drbd
Summary:	kernel module with drbd - a block device designed to build high availibility clusters
Summary(pl):	Modu kernela do drbd - urzdzenia blokowego dla klastrw o wysokiej niezawodnoci
Release:	%{rel}@%{_kernel_ver_str}
Group:		Base/Kernel
Prereq:		/sbin/depmod
%{!?_without_dist_kernel:%requires_releq_kernel_up}
Requires:	drbdsetup

%description -n kernel-block-drbd
drbd is a block device which is designed to build high availability
clusters. This is done by mirroring a whole block device via (a
dedicated) network. You could see it as a network RAID1.

%description -n kernel-block-drbd -l pl
drbd jest urzdzeniem blokowym zaprojektowanym dla klastrw o wysokiej
niezawodnoci. drbd dziaa jako mirroring caego urzdzenia blokowego
przez (dedykowan) sie. Moe by widoczny jako sieciowy RAID1.

%package -n kernel-smp-block-drbd
Summary:	SMP kernel module with drbd - a block device designed to build high availibility clusters
Summary(pl):	Modu kernela SMP do drbd - urzdzenia blokowego dla klastrw o wysokiej niezawodnoci
Release:	%{rel}@%{_kernel_ver_str}
Group:		Base/Kernel
Prereq:		/sbin/depmod
%{!?_without_dist_kernel:%requires_releq_kernel_smp}
Requires:	drbdsetup

%description -n kernel-smp-block-drbd
drbd is a block device which is designed to build high availability
clusters. This is done by mirroring a whole block device via (a
dedicated) network. You could see it as a network RAID1.

%description -n kernel-smp-block-drbd -l pl
drbd jest urzdzeniem blokowym zaprojektowanym dla klastrw o wysokiej
niezawodnoci. drbd dziaa jako mirroring caego urzdzenia blokowego
przez (dedykowan) sie. Moe by widoczny jako sieciowy RAID1.

%prep
%setup -q -n %{name}
%if %{_kernel24}
%patch -p1
%endif

%build

# SMP begin
%{__make} \
%ifarch %{ix86}
	KAF_i386="%{rpmcflags} -malign-loops=2 -malign-jumps=2 -malign-functions=2 -fomit-frame-pointer" \
%else
%ifarch %{alpha}
	KAF_alpha="%{rpmcfalgs} -ffixed8 -mno-fp-regs" \
%endif
%endif
	SMPFLAG="-D__SMP__ -D__KERNEL_SMP=1" \
	KERNVER="%{_kernel_ver}" \
	INCLUDE="-I%{_kernelsrcdir}/include" \
	DEBUGFLAGS="%{rpmcflags} %{?debug:-DDBG}" \
	CC="%{kgcc}"

mv -f drbd/drbd.o drbd-smp.o
# SMP end

# UP begin
%{__make} \
%ifarch %{ix86}
	KAF_i386="%{rpmcflags} -malign-loops=2 -malign-jumps=2 -malign-functions=2 -fomit-frame-pointer" \
%else
%ifarch %{alpha}
	KAF_alpha="%{rpmcfalgs} -ffixed8 -mno-fp-regs" \
%endif
%endif
	SMPFLAG="" \
	KERNVER="%{_kernel_ver}" \
	INCLUDE="-I%{_kernelsrcdir}/include" \
	DEBUGFLAGS="%{rpmcflags} %{?debug:-DDBG}" \
	CC="%{kgcc}"
# SMP end

%install
rm -rf $RPM_BUILD_ROOT
install -d $RPM_BUILD_ROOT{%{_sbindir},%{_mandir}/man{5,8},%{_sysconfdir}} \
	$RPM_BUILD_ROOT{/etc/rc.d/init.d,/etc/ha.d/resource.d}

install -d $RPM_BUILD_ROOT/lib/modules/%{_kernel_ver}{,smp}/misc
install drbd/drbd.o $RPM_BUILD_ROOT/lib/modules/%{_kernel_ver}/misc/drbd.o
install drbd-smp.o $RPM_BUILD_ROOT/lib/modules/%{_kernel_ver}smp/misc/drbd.o

install user/drbdsetup $RPM_BUILD_ROOT%{_sbindir}
install scripts/drbd.conf $RPM_BUILD_ROOT%{_sysconfdir}
install scripts/drbd $RPM_BUILD_ROOT/etc/rc.d/init.d
ln -sf /etc/rc.d/init.d/drbd $RPM_BUILD_ROOT/etc/ha.d/resource.d/datadisk

install documentation/drbd.conf.5 $RPM_BUILD_ROOT%{_mandir}/man5
install documentation/drbdsetup.8 $RPM_BUILD_ROOT%{_mandir}/man8

%clean
rm -rf $RPM_BUILD_ROOT

%post   -n kernel-block-drbd
/sbin/depmod -a

%postun -n kernel-block-drbd
/sbin/depmod -a

%post   -n kernel-smp-block-drbd
/sbin/depmod -a

%postun -n kernel-smp-block-drbd
/sbin/depmod -a

%post -n drbdsetup
/sbin/chkconfig --add drbd
if [ -f /var/lock/subsys/drbd ]; then
	/etc/rc.d/init.d/drbd restart >&2
else
	echo "Run \"/etc/rc.d/init.d/drbd start\" to start drbd service." >&2
fi

%preun -n drbdsetup
if [ "$1" = "0" ]; then
	if [ -f /var/lock/subsys/drbd ]; then
		/etc/rc.d/init.d/drbd stop
	fi
	/sbin/chkconfig --del drbd
fi

%files -n drbdsetup
%defattr(644,root,root,755)
%attr(755,root,root) %{_sbindir}/drbdsetup
%attr(755,root,root) /etc/rc.d/init.d/drbd
%attr(755,root,root) %{_sysconfdir}/ha.d/resource.d/datadisk
%config(noreplace) %verify(not size mtime md5) %{_sysconfdir}/drbd.conf
%{_mandir}/man[58]/*

%files -n kernel-block-drbd
%defattr(644,root,root,755)
%doc ChangeLog README TODO
/lib/modules/%{_kernel_ver}/misc/*

%files -n kernel-smp-block-drbd
%defattr(644,root,root,755)
%doc ChangeLog README TODO
/lib/modules/%{_kernel_ver}smp/misc/*

%define date	%(echo `LC_ALL="C" date +"%a %b %d %Y"`)
%changelog
* %{date} PLD Team <feedback@pld.org.pl>
All persons listed below can be reached at <cvs_login>@pld.org.pl

$Log: drbd.spec,v $
Revision 1.33  2002/11/17 20:14:41  kloczek
- release 14: rebuild against kernel 2.2.22-6.

Revision 1.32  2002/11/02 11:29:55  ankry
- rel. 13 (rebuild against kernel 2.2.22-4)

Revision 1.31  2002/10/12 12:54:58  marcus
- rel.12 (for kernel 2.2.22-3)

Revision 1.30  2002/10/02 17:30:53  marcus
- rel.11
- use new %5doc
- fixed %%files

Revision 1.29  2002/10/02 00:12:31  kloczek
- release 10: rebuild against kernel 2.2.22.

Revision 1.28  2002/09/15 19:34:11  kloczek
- release 9: rebuild against kernel 2.2.21-7.

Revision 1.27  2002/09/06 15:31:57  misiek
- use proper compiler

Revision 1.26  2002/08/18 17:30:06  kloczek
- release 8: rebuild against kernel 2.2.21.

Revision 1.25  2002/04/25 16:13:41  arturs
fixed a small typo

Revision 1.24  2002/03/17 16:06:25  dzimi

- update release numbers to build with new kernel release

Revision 1.23  2002/03/13 16:33:56  mkochano
- Typos.

Revision 1.22  2002/03/04 22:48:04  marcus
- use new ver-rel macros
- rel.6.

Revision 1.21  2002/02/26 15:30:12  qboosh
- use requires_releq_kernel_{up,smp} macros, release 5

Revision 1.20  2002/02/23 21:28:05  saq
- change Conflicts: wrong-kernel to Requires: right-kernel
- release 4, STBR

Revision 1.19  2002/02/23 01:58:09  kloczek
- adapterized.

Revision 1.18  2002/02/22 23:28:48  kloczek
- removed all Group fields translations (our rpm now can handle translating
  Group field using gettext).

Revision 1.17  2002/02/11 01:53:32  kloczek
- adapterized.

Revision 1.16  2002/02/10 18:59:09  marcus
- some fixes, rel 3. (for build with 2.2.20-10 and new 2.4)

Revision 1.15  2002/01/28 03:44:01  kloczek
- release 2.

Revision 1.14  2002/01/26 21:51:04  hunter
- s/misc/block/ after %if %{_kernel24}

Revision 1.13  2002/01/18 02:12:46  kloczek
perl -pi -e "s/pld-list\@pld.org.pl/feedback\@pld.org.pl/"

Revision 1.12  2001/12/16 00:53:09  kloczek
- added conditionaly (depending on %_without_dist_kernel)
  BuildRequirss: kernel-headers >= 2.2.20.

Revision 1.11  2001/12/16 00:15:17  marcus
- updated to 0.5.8.1
- smp subpackage builds with 2.2 too!

Revision 1.10  2001/11/14 08:37:15  filon
- added _without_dist_kernel option
- use _kernel_ver_str in release

Revision 1.9  2001/09/17 11:58:49  qboosh
- removed English "es" translations

Revision 1.8  2001/09/14 20:52:09  saq
- removed Conflicts: kernel != kernel_ver from main package (unneeded)
- reordered the descriptions
- drbdsetup doesn't require drbd (unavailable)
- drbdsetup prereq: chkconfig (should it prereq rc-scripts?)
- the modules conflict kernel-{smp,up}
- %%if 0 changed to %%if %%{_kernel24} (SMP builds under 2.4)
- -D__KERNEL_SMP=1 to SMP build options

Revision 1.7  2001/09/09 21:52:19  kloczek
- use %%{_kernel_ver} only in Release field in with kernel modules packages,
- added "Requires: drbdsetup" for kernel modules packages.

Revision 1.6  2001/09/09 13:59:05  saq
- typo (LF missing)

Revision 1.5  2001/09/08 19:03:34  kloczek
- standarized %post/%preun,
- Prereq: rc-scripts .. not chkconfig,
- merge some translations from drnd-utils.spec from CNV.

Revision 1.4  2001/09/08 17:05:16  kloczek
- added suport for building both up and smp modules in separated packages
  (build smp subpackage is ifdefed because seems building drbd with for SMP
  is broken),
- move kernel module to kernel-{,smp}-block-drbd subpackages.

Revision 1.3  2001/09/08 08:17:21  qboosh
- fixed URL, added Source0 URL
- proper summaries/descriptions (this is really not heartbeat package...)
- added using standard kernel module build procedure
- separated userland tools into drbdsetup subpackage
- kernel 2.4 compatibility patch (not tested)

Revision 1.2  2001/07/04 04:38:12  kloczek
- adapterized and partialy rewrited byt still NYF.
